/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Thumbs for Firefox.
 *
 * The Initial Developer of the Original Code is Jesse Ruderman.
 * Portions created by the Initial Developer are Copyright (C) 2004
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */



/*********************************************************/
/*                 Context menu item                     */
/*********************************************************/

// Most of this section is based on IEView's context menu code, but heavily modified and simplified.

function thumbsContext() {
  document.getElementById("thumbs-popup-selected-text").hidden = 
    ! (gContextMenu.isTextSelected);

  // also check whether links are selected?
}

function contextInit() {
  var menu = document.getElementById("contentAreaContextMenu");
  menu.addEventListener("popupshowing", thumbsContext, false);
}
window.addEventListener("load", contextInit, false);


/*********************************************************/
/* Command used by toolbar button and context menu item  */
/*********************************************************/


function thumbs(event)
{


  function getBoolPref ( prefname, def )
  {
    try { 
      var pref = Components.classes["@mozilla.org/preferences-service;1"]
                         .getService(Components.interfaces.nsIPrefBranch);
      return pref.getBoolPref(prefname);
    }
    catch(er) {
      return def;
    }
  }


  // Put _content into a singleton so that the script in chrome://thumbs/content/thumbs.html can find it.
  
  Components.
    classes["@squarefree.com/thumbs-singleton;1"].
      getService(Components.interfaces.nsIThumbsSingleton).
        setTGPWindow(_content);

  // Including large amounts of untrusted content (images) at a chrome url is not great for security, and
  // isn't strictly necessary, but it allows us to do nice things like avoid
  // memory leaks and dangling pointers.

  if ("whereToOpenLink" in window) {
	  // window.open sorta ensures that the content area is totally ours, which is great for security!
	  var where = whereToOpenLink(event);
	  
	  where = {
	    "current" : (getBoolPref("extensions.thumbs.opentabfor.toolbarbutton", true) ? "tab" : "window"),
	    "tab" : "tab",
	    "tabshifted" : "tabshifted",
	    "window" : "window"
	  }[where];
	  
	  if (where)
	    openUILinkIn("chrome://thumbs/content/thumbs.html", where);
	}
	else {
    // Firefox 0.9.3 or below
	  window.open("chrome://thumbs/content/thumbs.html");
	}
	
}
